!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!! Program for reading Meteograms extracted by COSMO                !!!
!!! Last Modified: October 13, 2023                                  !!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!Variable declearation!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	Character(len=110)	:: cbuffer1, cstation, csoil_type

	Integer	:: istn, jstn 
	Integer	:: idd, imm, iyyyy, ihh, imn, isc
	Integer	:: jdd, jmm, jyyyy, jhh, jmn, jsc
	Integer	:: itime_step
	Integer	:: isoil_type
	Integer	:: k, kk, kkhalf

	Real :: etime 
	Real :: hsurf, fr_land, alat, alon, fc
	Real :: ps, dpsdt
	Real :: Pmain,Tgrd,Qv,Qc,QI,Rel_hum,clc,Clc_Con,u,v,speed,hml,speedkt,wd
	Real :: Phalf, w, tkvm, tkvh, hhl
	Real :: TCM,TCH,Z0,SHFL,UMFL,LHFL,VMFL,QV_S,RUNOFF_S,RUNOFF_G
	Real :: LAI,VIO3,PLCOV,HMO3,ROOTDP
	Real :: T_SNOW,W_SNOW,T_S,W_I,T_G,FRESHSNW,RHOSNOW,H_SNOW,SNOW_MELT
	Real :: T_SO0,T_SO1,T_SO2,T_SO3,T_SO4,T_SO5,T_SO6,T_SO7,T_SO8
	Real :: W_SO1,W_SO2,W_SO3,W_SO4,W_SO5,W_SO6,W_SO7,W_SO8
	Real :: W_SO_ICE1,W_SO_ICE2,W_SO_ICE3,W_SO_ICE4,W_SO_ICE5,             &
	        W_SO_ICE6,W_SO_ICE7,W_SO_ICE8
	Real :: T2M,U10M, TD2M, V10M, TMIN2M, VBMAX10M, TMAX2M, WD10M,WS10M
	Real :: SOBT,THBT,SOBS,THBS,SWDIRS_RAD,SWDIFDS_RAD,SWDIFUS_RAD,PABS,   &
	        ALB
	Real :: RAIN_GSPRA,RAIN_GSPAM,SNOW_GSPRA,SNOW_GSPAM,RAIN_CONRA,        &
	        RAIN_CONAM,SNOW_CONRA,SNOW_CONAM,TOTAL_RA,TOTAL_AM
	Real :: CLCH,CLCM,CLCL,CLCT

	Real, Dimension(25,8)	:: soiltmp, wsoil, wsoilice
	Real, Dimension(8)	:: soildepth

	Data soildepth / 0.005, 0.02, 0.06, 0.18, 0.54, 1.62, 4.86, 14.58 /

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!Files!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

	Open (1, file = './M-STN-DDMonYYYY-00', form='formatted')
!	Open (1, file = 'M-TVM-09Oct2023-00', form='formatted')

	Open (11, file = 'M-Out-TS.dat', form='formatted')
	Open (12, file = 'M-Out-ZZ.dat', form='formatted')
	Open (13, file = 'M-Out-HL1.dat', form='formatted')
	Open (14, file = 'M-Out-HL2.dat', form='formatted')
	Open (15, file = 'M-Out-SOIL.dat', form='formatted')

	Write (11, 5) '      TIME', '   FR_LAND', '       LAT', '       LON', &
                      '        FC', '  SOILTYPE', '        PS', '     DPSDT', &
                      '       TCM', '       TCH', '        Z0', '      SHFL', &
                      '      LHFL', '      UMFL', '      VMFL', '      QV_S', &
                      '  RUNOFF_S', '  RUNOFF_G', '       LAI', '      VIO3', &
                      '     PLCOV', '      HMO3', '    ROOTDP', '    T_SNOW', &
                      '    W_SNOW', '       T_S', '       W_I', '       T_G', &
                      '  FRESHSNW', '  RHO_SNOW', '    H_SNOW', ' SNOW_MELT', &
                      '      TSO0', '      TSO1', '      TSO2', '      TSO3', &
                      '      TSO4', '      TSO5', '      TSO6', '      TSO7', &
                      '      TSO8', '     W_SO1', '     W_SO2', '     W_SO3', &
                      '     W_SO4', '     W_SO5', '     W_SO6', '     W_SO7', &
                      '     W_SO8', ' W_SO_ICE1', ' W_SO_ICE2', ' W_SO_ICE3', &
                      ' W_SO_ICE4', ' W_SO_ICE5', ' W_SO_ICE6', ' W_SO_ICE7', &
                      ' W_SO_ICE8', '       T2M', '      TD2M', '      U10M', &
                      '      V10M', '    TMIN2M', '    TMAX2M', '  VBMAX10M', &
                      '      SOBT', '      THBT', '      SOBS', '      THBS', &
                      '    SWDIRS', '   SWDIFDS', '   SWDIFUS', '      PABS', &
                      '       ALB', 'RAIN_GSPRA', 'RAIN_GSPAM', 'SNOW_GSPRA', &
                      ' SNOWGSPAM', 'RAIN_CONRA', 'RAIN_CONAM', 'SNOW_CONRA', &
                      'SNOW_CONAM', '   TOTALRA', '   TOTALAM', '      CLCH', &
                      '      CLCM', '      CLCL', '      CLCT' 

	Write (12, 5) 'TIME', 'K', 'Pmain', 'T', 'QV', 'QC', 'QI',      &
                      'RELHUM', 'CLC', 'CLCCON', 'U', 'V', 'WS', 'HML', &
                       'wskt','wd'

	Write (13, 5) 'TIME', 'K', 'Phalf', 'W', 'HHL'

	Write (14, 5) 'TIME', 'K', 'Phalf', 'W', 'TKVM', 'TKVH', 'HHL'

	Write (15, 5) 'TIME', 'SOILDEPTH', 'SOILTEMP', 'WSOIL', 'WSOILICE'

 5	Format (88(1x, a10))

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!One time!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	Read (1, 10, end=100) cbuffer1   !1
 10	Format (a110)
	Read (cbuffer1, 111) cstation, istn, jstn
 111	Format (19x, a3, 33x, i6, 6x, i6) 

	Read (1, 10, end=100) cbuffer1   !2
	Read (cbuffer1, 112) idd, imm, iyyyy, ihh, imn, isc
 112	Format (23x, i2, 1x, i2, 1x, i4, 2x, i2, 1x, i2, 1x, i2)

	Read (1, 10, end=100) cbuffer1   !3
 	Read (cbuffer1, 113) hsurf
 113	Format (18x, f10.3)
	
	Read (1, 10, end=100) cbuffer1   !4
 	Read (cbuffer1, 113) fr_land
	Read (1, 10, end=100) cbuffer1   !5
 	Read (cbuffer1, 113) alat
	Read (1, 10, end=100) cbuffer1   !6
 	Read (cbuffer1, 113) alon
	Read (1, 10, end=100) cbuffer1   !7
 	Read (cbuffer1, 113) fc

	Read (1, 10, end=100) cbuffer1   !8
	Read (cbuffer1, 114) csoil_type, isoil_type
 114	Format (18x, a10, 1x, i6)

	Read (1, 10, end=100) cbuffer1   !9

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!To be printed multiple times!!!!!!!!!!!!!!!!!!!!!!!!!!!!
!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
	Do j = 1, 25

	Read (1, 10, end=100) cbuffer1
	Read (cbuffer1, 115) jdd, jmn, jyyyy, jhh, jmn, jsc, etime, itime_step
 115	Format(33x, i2, 1x, i2, 1x, i4, 2x, 3(i2, 1x), 5x, f11.2, 16x, i12)

	Read (1, 10, end=100) cbuffer1
	Read (cbuffer1, 116) ps, dpsdt
 116	Format (12x, f7.1, 17x, f7.1)
	
	Read (1, 10, end=100) cbuffer1
	Read (1, 10, end=100) cbuffer1
	Read (1, 10, end=100) cbuffer1
	Read (1, 10, end=100) cbuffer1
	
	Do jj = 1, 50
	Read (1, 10, end=100)cbuffer1
	Read(cbuffer1,117)kk, Pmain, Tgrd, Qv, Qc, QI, Rel_hum, clc, Clc_Con,  &
        u, v, speed, hml
 117	Format(1x, i2, 1x, f7.2, 1x, f6.2, 2x, f6.3, 1x, f7.3, 1x, f7.3,   &
        2x, f6.2, 3x, f5.2, 2x, f6.2, 1x, f7.2, 1x, f7.2, 2x, f6.2, 2x, &
        f7.1) 
	speedkt=1.94384*speed
	wd=(atan2(u,v)*(180.0/3.14159265359))+180.0
	Write (12, 151) etime, float(kk), Pmain, Tgrd, Qv, Qc, QI, Rel_hum,    &
                        clc, Clc_Con, u, v, speed, hml,speedkt,wd

	Enddo

	Write (12, *)

	Do jk = 1, 4
	Read (1, 10, end=100)cbuffer1
	Enddo

	Read (1, 10, end=100)cbuffer1
	Read (cbuffer1, 118) kkhalf, Phalf, w, hhl
 118	Format (1x, i2, f8.2, f10.3, 10x, 10x, f9.1)

	Write (13, 151) etime, float(kkhalf), Phalf, w, hhl

	Do ik = 1, 49
	Read (1, 10, end=100)cbuffer1
	Read (cbuffer1, 119) kkhalf, Phalf, w, tkvm, tkvh, hhl
 119	Format (1x, i2, f8.2, f10.3, f10.3, f10.3, f9.1)
	Write (13, 151) etime, float(kkhalf), Phalf, w, hhl
	Write (14, 151) etime, float(kkhalf), Phalf, w, tkvm, tkvh, hhl
	Enddo
	Read (1, 10, end=100)cbuffer1
	Read (cbuffer1, 118) kkhalf, Phalf, w, hhl
	Write (13, 151) etime, float(kkhalf), Phalf, w, hhl

	Read (1, 10, end=100) cbuffer1
	Read (1, 10, end=100) cbuffer1
	Read (cbuffer1,120)TCM
 120	format (38x,f13.5)
	Read (1, 10, end=100) cbuffer1
	Read (cbuffer1,120)TCH
	read (1,10, end=100)cbuffer1
	read(cbuffer1,120)Z0
	Read (1, 10, end=100)cbuffer1
	read(cbuffer1,121)SHFL,UMFL
 121	format(38x,f11.3,39x,f11.3)
	Read (1, 10, end=100)cbuffer1
	read(cbuffer1,121)LHFL,VMFL
	Read (1, 10, end=100) cbuffer1
	read (cbuffer1,120)QV_S
	Read (1, 10, end=100) cbuffer1
	read (cbuffer1,120)RUNOFF_S
	Read (1, 10, end=100) cbuffer1
	read (cbuffer1,120)RUNOFF_G
	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,122)LAI,VIO3
 122	format(38x,f11.3,38x,f11.3)
	Read (1, 10, end=100) cbuffer1
	read (cbuffer1,122)PLCOV,HMO3
	Read (1, 10, end=100) cbuffer1
	read (cbuffer1,120)ROOTDP
	Read (1, 10, end=100) cbuffer1
	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,123)T_SNOW,W_SNOW
 123	format(38x,f11.3,38x,f11.3)
	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,123)T_S,W_I
	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,123)T_G,FRESHSNW
	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,124)RHO_SNOW
 124	format(87x,f11.3)
	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,124)H_SNOW
	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,123)SNOW_MELT
	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,125)T_SO0
 125	format(38x,f11.3)

	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,126)T_SO1,W_SO1,W_SO_ICE1
 126	format(38x,f11.3,15x,f11.3,14x,f11.3)
	
	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,126)T_SO2,W_SO2,W_SO_ICE2

	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,126)T_SO3,W_SO3,W_SO_ICE3

	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,126)T_SO4,W_SO4,W_SO_ICE4

	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,126)T_SO5,W_SO5,W_SO_ICE5

	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,126)T_SO6,W_SO6,W_SO_ICE6

	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,126)T_SO7,W_SO7,W_SO_ICE7

	Read (1, 10, end=100) cbuffer1
	read(cbuffer1,126)T_SO8,W_SO8,W_SO_ICE8
	read(1,10)cbuffer1
	Read(1,10,end=100)cbuffer1

	read(cbuffer1,127) T2M, U10M
 127	format(38x,f11.3,38x,f11.3)

	read(1,10,end=100)cbuffer1
	read(cbuffer1,127)TD2M,V10M
! 127	format(38x,f11.3,38x,f11.3)

	
 !	WD10M=(atan2(U10M,V10M)*(180.0/3.14159265359))+180.0
 !	WS10M=sqrt((U10M*U10M)+(V10m*V10M))


	read(1,10,end=100)cbuffer1
	read(cbuffer1,127)TMIN2M,VBMAX10M
! 127	format(38x,f11.3,38x,f11.3)

	read(1,10,end=100)cbuffer1
	read(cbuffer1,127)TMAX2M
 128	format(38x,f11.3)

	read(1,10,end=100)cbuffer1
	read(1,10,end=100)cbuffer1
	read(cbuffer1,127)SOBT,THBT
! 127	format(38x,f11.3,38x,f11.3)

	read(1,10,end=100)cbuffer1
	read(cbuffer1,127)SOBS,THBS
! 127	format(38x,f11.3,38x,f11.3)

	read(1,10,end=100)cbuffer1
	read(cbuffer1,128)SWDIRS_RAD
! 128	format(38x,f11.3)

	read(1,10,end=100)cbuffer1
	read(cbuffer1,128)SWDIFDS_RAD
! 128	format(38x,f11.3)

	read(1,10,end=100)cbuffer1
	read(cbuffer1,128)SWDIFUS_RAD
 !128	format(38x,f11.3)

	read(1,10,end=100)cbuffer1
	read(cbuffer1,127)PABS,ALB
 !127	format(38x,f11.3,38x,f11.3)

	read(1,10,end=100)cbuffer1
	read(1,10,end=100)cbuffer1
	read(1,10,end=100)cbuffer1

	read(1,10,end=100)cbuffer1
	read(cbuffer1,130)RAIN_GSPRA,RAIN_GSPAM,CLCH
 130	FORMAT(18x,f11.3,f17.3,26x,f11.3)

	read(1,10,end=100)cbuffer1
	read(cbuffer1,130)SNOW_GSPRA,SNOW_GSPAM,CLCM

	read(1,10,end=100)cbuffer1
	read(cbuffer1,130)RAIN_CONRA,RAIN_CONAM,CLCL

	read(1,10,end=100)cbuffer1
	read(cbuffer1,130)SNOW_CONRA,SNOW_CONAM,CLCT

	read(1,10,end=100)cbuffer1
	read(cbuffer1,129)TOTAL_RA,TOTAL_AM
 129	format(18x,f11.3,f16.3)

	read(1,10,end=100)cbuffer1
	read(1,10,end=100)cbuffer1

 151	Format (88(1x, f10.3))

	Write(11, 151) etime, fr_land, alat, alon,                      &
                       fc, float(isoil_type), ps, DPSDT,                &
                       TCM, TCH, Z0, SHFL,                              &
                       LHFL, UMFL, VMFL, QV_S, 				&
		       RUNOFF_S, RUNOFF_G, LAI, VIO3,                   &
                       PLCOV, HMO3, ROOTDP, T_SNOW, 			&
		       W_SNOW, T_S, W_I, T_G, 				&
		       FRESHSNW, RHOSNOW, H_SNOW, SNOW_MELT, 		&
		       T_SO0, T_SO1, T_SO2, T_SO3,    			&
                       T_SO4, T_SO5, T_SO6, T_SO7, 			&
		       T_SO8, W_SO1, W_SO2, W_SO3, 			&
		       W_SO4, W_SO5, W_SO6, W_SO7, 			&
		       W_SO8, W_SO_ICE1, W_SO_ICE2, W_SO_ICE3,		&
		       W_SO_ICE4, W_SO_ICE5, W_SO_ICE6, W_SO_ICE7, 	&
		       W_SO_ICE8, T2M, TD2M, U10M, 			&
		       V10M, TMIN2M, TMAX2M, VBMAX10M, 			&
		       SOBT, THBT, SOBS, THBS,				&
		       SWDIRS_RAD, SWDIFDS_RAD, SWDIFUS_RAD, PABS,      &
		       ALB, RAIN_GSPRA, RAIN_GSPAM, SNOW_GSPRA,         &
		       SNOW_GSPAM, RAIN_CONRA, RAIN_CONAM, SNOW_CONRA,  &
		       SNOW_CONAM, TOTAL_RA, TOTAL_AM, CLCH,            &
		       CLCM, CLCL, CLCT
	Write (13, *)
	Write (14, *)

	itime = int(etime + 1.0)

	soiltmp(itime,1) = T_SO0
	soiltmp(itime,2) = T_SO1
	soiltmp(itime,3) = T_SO2
	soiltmp(itime,4) = T_SO3
	soiltmp(itime,5) = T_SO4
	soiltmp(itime,6) = T_SO5
	soiltmp(itime,7) = T_SO6
	soiltmp(itime,8) = T_SO7

	wsoil(itime,1) = W_SO0
	wsoil(itime,2) = W_SO1
	wsoil(itime,3) = W_SO2
	wsoil(itime,4) = W_SO3
	wsoil(itime,5) = W_SO4
	wsoil(itime,6) = W_SO5
	wsoil(itime,7) = W_SO6
	wsoil(itime,8) = W_SO7

	wsoilice(itime,1) = W_SO_ICE0
	wsoilice(itime,2) = W_SO_ICE1
	wsoilice(itime,3) = W_SO_ICE2
	wsoilice(itime,4) = W_SO_ICE3
	wsoilice(itime,5) = W_SO_ICE4
	wsoilice(itime,6) = W_SO_ICE5
	wsoilice(itime,7) = W_SO_ICE6
	wsoilice(itime,8) = W_SO_ICE7

	Write (15, 152) etime, soildepth(1), soiltmp(itime,1), wsoil(itime,1), wsoilice(itime,1)
	Write (15, 152) etime, soildepth(2), soiltmp(itime,2), wsoil(itime,2), wsoilice(itime,2)
	Write (15, 152) etime, soildepth(3), soiltmp(itime,3), wsoil(itime,3), wsoilice(itime,3)
	Write (15, 152) etime, soildepth(4), soiltmp(itime,4), wsoil(itime,4), wsoilice(itime,4)
	Write (15, 152) etime, soildepth(5), soiltmp(itime,5), wsoil(itime,5), wsoilice(itime,5)
	Write (15, 152) etime, soildepth(6), soiltmp(itime,6), wsoil(itime,6), wsoilice(itime,6)
	Write (15, 152) etime, soildepth(7), soiltmp(itime,7), wsoil(itime,7), wsoilice(itime,7)
	Write (15, 152) etime, soildepth(8), soiltmp(itime,8), wsoil(itime,8), wsoilice(itime,8)
	Write (15, *)

 152	Format (10(1x, f10.3))

	Enddo

 100	Continue

	Stop
	End
